/******************************************************************************
 * shaderProgramShadowMap.h 
 * implements the GLSL shader for shadow map application
 * Copyright (C) 2010 Marc Gissler <gisslerm@informatik.uni-freiburg.de>
 ******************************************************************************/
#ifndef SHADERPROGRAM_SHADOWMAP_H
#define SHADERPROGRAM_SHADOWMAP_H

#include "globals.h"
#include "shaderProgram.h"

// ------------------------------------------------------------
// defines thes shader program shadow map class
// 

class CShaderProgramShadowMap : public CShaderProgram
{
public:
	// constructor/destructor
	CShaderProgramShadowMap();
	~CShaderProgramShadowMap();

	// employs the shader in the next render pass
	virtual void use();

	// sets the the shadow strength
	void setShadowFactor(GLfloat shadowFactor);

	// sets the color of the shadow
	void setShadowColor(GLfloat r, GLfloat g, GLfloat b, GLfloat a);

private:
	GLuint  m_shadowMapUniform;
	
	GLint   m_shadowColorUniform;
	GLfloat m_shadowColor[4];
	
	GLint   m_shadowFactorUniform;
	GLfloat m_shadowFactor;
};

#endif
